diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index 7169216c3..b49f0c2e6 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -52,12 +52,20 @@ public class ItemBlock<T extends BlockLogic> extends Item {
         final boolean placeNextToExisting = !world.canPlaceInsideBlock(blockPos) ||
             (this.block.hasTag(BlockTags.PLACE_OVERWRITES) && this.block == world.getBlockType(blockPos));
 
-        if (placeNextToExisting) blockPos = blockPos.add(side.getDirection(), new TilePos());
+        if (placeNextToExisting) blockPos = blockPos.add(side.direction(), new TilePos());
 
         if (!world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) return false;
-        
-        if (!world.setBlockTypeData(blockPos, this.block, meta)) return false;
-        if (!selfStack.consumeItem(player)) return false; // should always be true
+
+        final var pbloc = world.getBlockType(blockPos);
+        final int pdata = world.getBlockData(blockPos);
+
+        if (!world.setBlockTypeDataRaw(blockPos, this.block, meta)) return false;
+
+        if (pbloc != this.block || pdata != meta) {
+            pbloc.onRemoved(world, blockPos, pdata);
+        }
+
+        selfStack.consumeItem(player);
 
         if (player == null) {
             this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
@@ -65,6 +73,8 @@ public class ItemBlock<T extends BlockLogic> extends Item {
             this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         }
 
+        this.block.onPlacedByWorld(world, blockPos);
+
         if (this.block.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
             final TileEntity tileEntity = world.getTileEntity(blockPos);
             if (tileEntity != null) {
@@ -86,7 +96,7 @@ public class ItemBlock<T extends BlockLogic> extends Item {
         blockPos = new TilePos(blockPos).add(direction);
         @NotNull Block<?> b = world.getBlockType(blockPos);
         if (b == Blocks.AIR || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-            onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
+            onUseOnBlock(selfStack, world, null, blockPos, direction.side(), 0.5, 0.5);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index e7a7a2cca..4f2dfce00 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -24,7 +24,7 @@ public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
 
         final Side pside;
         if (player == null || player.isSneaking() || world.getBlockType(bp) != this.block) {
-            if (!world.canPlaceInsideBlock(bp)) bp.add(side.getDirection());
+            if (!world.canPlaceInsideBlock(bp)) bp.add(side.direction());
             pside = ladder.getSideForPlacement(world, bp, side);
         } else {
             xHit = 0.5;
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index 7ba51df41..8544fd687 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -49,7 +49,7 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
                 };
             if (canPlaceInto) break;
             shiftPos.add(side);
-            yHit -= side.getOffsetY();
+            yHit -= side.offsetY();
         } if (i == 2) { // for else
             return super.onUseOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
index 27389ac8b..8a48d1c90 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
@@ -39,7 +39,7 @@ public class ItemToolHoe extends ItemTool {
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        till(selfStack, null, world, blockPos.add(direction, new TilePos()), direction.getSide());
+        till(selfStack, null, world, blockPos.add(direction, new TilePos()), direction.side());
     }
 
     public boolean till(@NotNull ItemStack selfStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc blockPos, @NotNull Side side) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
index 895b76bff..aa60ed8df 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
@@ -36,7 +36,7 @@ public class ItemToolShovel extends ItemTool {
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        shovelBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.getSide());
+        shovelBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.side());
     }
 
     public boolean shovelBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player entityplayer, @NotNull TilePosc blockPos, @NotNull Side side) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
index 3d99468b8..7bb9605f1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
@@ -55,7 +55,7 @@ public class ItemToolSword extends Item
         blockPos = blockPos.add(direction, new TilePos());
         Block<?> b = world.getBlockType(blockPos);
         if (b == Blocks.PUMPKIN) {
-            world.setBlockTypeData(blockPos, Blocks.PUMPKIN_CARVED_IDLE, direction.getOpposite().getId());
+            world.setBlockTypeData(blockPos, Blocks.PUMPKIN_CARVED_IDLE, direction.opposite().id);
             selfStack.damageItem(1, null);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
index 473a2dd87..2f094e98d 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
@@ -27,7 +27,7 @@ public class NetEntryFallingBlock implements IVehicleEntry<EntityFallingBlock>,
 
     @Override
     public int getMovementPacketDelay() {
-        return 20;
+        return 3;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketBlockEvent.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketBlockEvent.java
index 182a0f0a8..91f0698a9 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketBlockEvent.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketBlockEvent.java
@@ -9,14 +9,18 @@ public class PacketBlockEvent extends Packet
     public int xLocation;
     public int yLocation;
     public int zLocation;
-    public int index;
-    public int data;
+    public byte index;
+    public byte data;
 
     public PacketBlockEvent()
     {
     }
 
-    public PacketBlockEvent(int x, int y, int z, int index, int data)
+    public PacketBlockEvent(int x, int y, int z, int index, int data) {
+        this(x,y,z, (byte)(0xFF & index), (byte)(0xff & data));
+    }
+
+    public PacketBlockEvent(int x, int y, int z, byte index, byte data)
     {
         xLocation = x;
         yLocation = y;
@@ -32,8 +36,8 @@ public class PacketBlockEvent extends Packet
         xLocation = dis.readInt();
         yLocation = dis.readShort();
         zLocation = dis.readInt();
-        index = dis.read();
-        data = dis.read();
+        index = dis.readByte();
+        data = dis.readByte();
     }
 
     @Override
@@ -43,8 +47,8 @@ public class PacketBlockEvent extends Packet
         dos.writeInt(xLocation);
         dos.writeShort(yLocation);
         dos.writeInt(zLocation);
-        dos.write(index);
-        dos.write(data);
+        dos.writeByte(index);
+        dos.writeByte(data);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java
index bc3288510..53a2a78da 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java
@@ -50,7 +50,7 @@ public class PacketPlayerAction extends Packet
         xPosition = dis.readInt();
         yPosition = dis.read();
         zPosition = dis.readInt();
-        side = Side.getSideById(dis.read());
+        side = Side.fromId(dis.read());
         xHit = dis.readDouble();
         yHit = dis.readDouble();
     }
@@ -63,7 +63,7 @@ public class PacketPlayerAction extends Packet
         dos.writeInt(xPosition);
         dos.write(yPosition);
         dos.writeInt(zPosition);
-        dos.write(side.getId());
+        dos.write(side.id);
         dos.writeDouble(xHit);
         dos.writeDouble(yHit);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
index 21c0c9a58..7a21858aa 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
@@ -80,7 +80,7 @@ public class PacketUseOrPlaceItemStack extends Packet
         xPosition = dis.readInt();
         yPosition = dis.read();
         zPosition = dis.readInt();
-        direction = Direction.getDirectionById(dis.read());
+        direction = Direction.fromId(dis.read());
         xPlaced = dis.readDouble();
         yPlaced = dis.readDouble();
         type = dis.readByte();
@@ -103,7 +103,7 @@ public class PacketUseOrPlaceItemStack extends Packet
         dos.writeInt(xPosition);
         dos.write(yPosition);
         dos.writeInt(zPosition);
-        dos.write(direction.getId());
+        dos.write(direction.id);
         dos.writeDouble(xPlaced);
         dos.writeDouble(yPlaced);
         dos.writeByte(type);
diff --git a/game/core/src/main/java/net/minecraft/core/util/PackedField.java b/game/core/src/main/java/net/minecraft/core/util/PackedField.java
index 9b7791a95..98fc084eb 100644
--- a/game/core/src/main/java/net/minecraft/core/util/PackedField.java
+++ b/game/core/src/main/java/net/minecraft/core/util/PackedField.java
@@ -5,7 +5,7 @@ public final class PackedField {
     public final int mask;
 
     public PackedField(int offset, int size) {
-        assert offset >= 0 && size >= 0 && offset + size < 32;
+        assert offset >= 0 && size >= 0 && offset + size <= 32;
         this.offset = offset;
         this.mask = ((1 << size) - 1) << offset;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Axis.java b/game/core/src/main/java/net/minecraft/core/util/helper/Axis.java
index 53f2d815c..c72b69aa9 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Axis.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Axis.java
@@ -2,10 +2,23 @@ package net.minecraft.core.util.helper;
 
 public enum Axis {
 	
-	X, Y, Z, NONE;
+	X(0), Y(1), Z(2), 
 	
+	@Deprecated
+	NONE(-1, -1);
+	
+	private Axis(int xyzIndex) {
+		this(xyzIndex, (xyzIndex + 1) % 3);
+	}
+	private Axis(int xyzIndex, int yzxIndex) {
+		this.xyzIndex = xyzIndex;
+		this.yzxIndex = yzxIndex;
+	}
+
 	public boolean isVertical() {
 		return this == Y;
 	}
-	
+
+	public int xyzIndex;
+	public int yzxIndex;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
index 3e5f86a2f..b6b3061b1 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
@@ -2,7 +2,7 @@ package net.minecraft.core.util.helper;
 
 public class BlockParticleHelper {
     public static int encodeBlockData(int blockId, int meta, Side side) {
-        return blockId & 0x3FFF | (meta & 0xFF) << 14 | (side.getId() << 22);
+        return blockId & 0x3FFF | (meta & 0xFF) << 14 | (side.id << 22);
     }
 
     public static int decodeBlockID(int data) {
@@ -14,6 +14,6 @@ public class BlockParticleHelper {
     }
 
     public static Side decodeBlockSide(int data) {
-        return Side.getSideById(data >> 22 & 0xF);
+        return Side.fromId(data >> 22 & 0xF);
     }
 }
